#include "Map.h"

#include "SDL.h"
#include <fstream>
#include <math.h>
#include <cstdlib>
#include <time.h>
#include "CSRPG.h"
using namespace std;

/*
 * 	Map.cpp
 * 	Holds the implementation and constructor for the Map.h
 * 	class.
 *
 * 	Changelog:
 * 		Mike, Apr. 30
 */

void Map::loadMap(char *filename) {
	ifstream mapFile(filename);
	if(!mapFile) {
		fprintf(stderr,"Map %s not found..\n",filename);
		exit(1);
	}
	for(int r = 0; r < MAP_Y_SIZE; r++) {
		mapFile.getline(level[r],((MAP_X_SIZE+1)));
	}
	mapFile.close();
	printf("Loaded map file...\n");
}

Map::Map() {
	//srand((unsigned int)time(NULL));
	for(int c = 0; c < MAP_X_SIZE; c++) {
		for(int r = 0; r < MAP_Y_SIZE; r++) {
			//level[r][c] = '0';
			level[r][c] = rand() % MAX_TILES + '0';
		}
	}
}
