#ifndef _MAP_H_
#define _MAP_H_

#include <iostream>
#include <fstream>
#include "SpecialTiles.h"
using namespace std;

#define MAP_X_SIZE 100
#define MAP_Y_SIZE 100

/// A class which holds the current map, in char format.
/** This class can also load the level from a file, parse it,
 * and give it to us. It's rather nice.
 */
class Map {
	public:
		/// The constructor, puts in defaults to set off error trapping
		Map();
		/// Our level data, in characters '0' - '9'
		char level[MAP_Y_SIZE][MAP_X_SIZE];
		/// Loads a map from file.
		void loadMap(char *filename);
};

#endif
