#include "Player.h"
#include "npc.h"
#include "CSRPG.h"
#include "Quests.h"

/*
 * 	Player.cpp
 * 	Manages the constructor of the Player class
 */

Player::Player() {
	// our little cowboy samurai is all growed up now
	hp = 60;
	hp_max = 60;
	mp = 50;
	mp_max = 50;

	bIsHostile = 0;
	myName = "Player";
	whatToSay0 = "This Shouldn't Happen, I'm The Player";
	x = 25;
	y = 19;
	//bDrawMe = 1;
	rect.x = RES_X/2;
	rect.y = RES_Y/2;
	sprite = 0;
	heading = rand() % 3; // start him out in a random direction
	questptr = NULL;
	map = 0;
	gold = 0;
	mod = 1;
	ac_mod = 1;
	keys = 0;

	/* Normal mode */
	bHasMagic = 0;
	bHasHealSpell = 1;
	bHasFireSpell = 1;
	bHasLightningSpell = 1;
	bHasEarthSpell = 1;
	bHasMeteor = 1;
	bHasHandOfDeath = 1;
	bHasFullHeal = 1;

	// special spells
	bHasScornAndAbuse = 1;
	bHasMessiah = 1; // DEBUG ONLY!!!!
	bHasTheRapture = 1; 

	/*
		//Debug Mode
		
	bHasMagic = 0;
	bHasHealSpell = 1;
	bHasFireSpell = 1;
	bHasLightningSpell = 1;
	bHasEarthSpell = 1;
	bHasMeteor = 1;
	bHasHandOfDeath = 1;
	bHasFullHeal = 1;

	// special spells
	bHasScornAndAbuse = 1;
	bHasMessiah = 1;
	bHasTheRapture = 1;*/

	weapon_mod = 1;
	strength_mod = 1;
	agility_mod = 1;
	healingpotions = 2;
	manapotions = 0;
	experience = 1;
}

int Player::moveRelative(int dx, int dy) {
	// let's prevent double-move here...
	if(dx > 0) {
		heading = 3;
		dx = 1;
	}
	if(dx < 0) {
		heading = 1;
		dx = -1;
	}
	if(dy > 0) {
		heading = 2;
		dy = 1;
	}
	if(dy < 0) {
		heading = 0;
		dy = -1;
	}
	x += dx;
	y += dy;
	if(questptr) {
		// finding the completion of a quest
		if(questptr->map == map) {
			if(questptr->x == x && questptr->y == y) {
				printf("Quest %s completed\n",questptr->TheDescript.c_str());
				// hmm, figure out a way to do this?
				//gold++; // you did a quest hooray
				gold += GOLD_PER_QUEST;
				questptr->bDone = 1;
				if(questptr->bGivesKey) {
					// you got a key!
					keys++;
				}
				questptr = NULL;
				return 1; // I solved a quest, display the message!!!1
			}
		}
	}
	//mod = 1;
	return 0;
}
