#include "Quests.h"
#include "CSRPG.h"
#include "HUDController.h"
#include <string>

using namespace std;

string QuestMaster::GiveNextQuest(int map) {
	// returns the dialogue string for the next quest
	printf("made quest request\n");
	for(int i = 0; i < quests.size(); i++) {
		if(!quests[i]->bDone && quests[i]->map == map) {
			// found an undone quest on this floor
			printf("%s (%i,%i)\n",quests[i]->TheDescript.c_str(),quests[i]->x,quests[i]->y);
			return quests[i]->TheDescript;
		}
	}
	// could not find ANY undone quests
	printf("could not find any quests\n");
	string returnstring = "I have no work for you on this floor!";
	return returnstring;
}

Quest* QuestMaster::NextQuest(int map) {
	// not quite sure what this does right now :P
	printf("made quest request\n");
	for(int i = 0; i < quests.size(); i++) {
		if(!quests[i]->bDone && quests[i]->map == map) {
			// found an undone quest
			return quests[i];
		}
	}
	return NULL;
}

Quest::Quest() {
	// initialize a blank "example" quest
	x = 5;
	y = 5;
	map = 0;
	bDone = 0;
	TheDescript = "Get out of my office. Then come back in.";
	bGivesKey = 0;
}
/*void QuestMaster::loadQuests(char *filename) {
	printf("Loading quests\n");
	ifstream TheFile(filename);
	if(!TheFile) {
		fprintf(stderr,"Quests file %s missing\n",filename);
		exit(1);
	}
	while(!TheFile.eof()) {
		Quest* newQuest = new Quest();
		char *temp = new char[30];

		if(!newQuest) {
			fprintf(stderr,"Couldn't spawn new quest, maybe out of mem\n");
			exit(1);
		}
		newQuest->bDone = 0;
		TheFile.getline(temp,6);
		printf("Loaded %s\n",temp);
		newQuest->x = atoi(temp);
		TheFile.getline(temp,6);
		printf("Loaded %s\n",temp);
		newQuest->y = atoi(temp); // what y is it?
		TheFile.getline(temp,6);
		printf("Loaded %s\n",temp);
		newQuest->map = atoi(temp); // what map is it on?
		TheFile.getline(temp,100);
		printf("Loaded %s\n",temp);
		newQuest->TheDescript = temp;
		TheFile.getline(temp,6);
		printf("Loaded %s\n",temp);
		if(atoi(temp) > 0) {
			newQuest->bGivesKey = 1;
		} else {
			newQuest->bGivesKey = 0;
		}
		printf("Loaded %s (%i,%i,%i)\n",newQuest->TheDescript.c_str(),newQuest->x,newQuest->y,newQuest->map);
		printf("Testing quest to see if it's invalid\n");
		if(newQuest->x == 0 && newQuest->y == 0) {
			printf("Invalid quest\n");
			TheFile.close();
			delete newQuest;
			return;
		}
		printf("Adding quest to quest vector\n");
		quests.push_back(newQuest); // put the quest into the vector
		printf("Checking for EOF\n");
		if(TheFile.eof()) {
			printf("EOF\n");
			TheFile.close();
			delete newQuest;
			return;
		}
		delete[] temp;
		printf("I looped!\n");
	}
	TheFile.close();
}*/
void QuestMaster::loadQuests(char *filename) {
	ifstream TheFile(filename); 
	if(!TheFile) {
		fprintf(stderr,"Quest file %s missing\n",filename);
		exit(1);
	}
	char *tempc = new char[50];
	//quests.clear();
	while(!TheFile.eof()) {
		Quest *newQuest = new Quest();
		newQuest->bDone = 0; // failsafe
		// First, load X
		TheFile.getline(tempc,10);
		newQuest->x = atoi(tempc);
		// Now, load Y
		TheFile.getline(tempc,10);
		newQuest->y = atoi(tempc);
		// Load the floor
		TheFile.getline(tempc,10);
		newQuest->map = atoi(tempc);
		// Load the descriptor
		TheFile.getline(tempc,40);
		newQuest->TheDescript = tempc;
		// Load whether or not it gives you a key.
		TheFile.getline(tempc,4);
		if(atoi(tempc) > 0) {
			newQuest->bGivesKey = 1;
		} else {
			newQuest->bGivesKey = 0;
		}
		printf("Loaded Quest %s, (%i,%i,%i)\n",newQuest->TheDescript.c_str(),newQuest->x,newQuest->y,newQuest->map);
		if(newQuest->x == 0 && newQuest->y == 0) {
			printf("invalid\n");
			delete newQuest;
			delete tempc;
			//SDL_Delay(2000);
			TheFile.close();
			return;
		}
		if(TheFile.eof()) {
			printf("eof...\n");
			printf("pushing back on eof\n");
			quests.push_back(newQuest);
			TheFile.close();
			delete tempc;
			return;
		}
		// normal termination, thank god
		printf("pushing back\n");
		quests.push_back(newQuest); // THIS CRASHES
		printf("looping\n");
	}
	TheFile.close();
	delete[] tempc;
}

QuestMaster::QuestMaster() {
	printf("QuestMaster()\n");
}
