#include "Shops.h"
#include <fstream>
#include "CSRPG.h"
using namespace std;

/*
	I'M A CONSUMER WHORE
*/

void Shop::loadItems(char *name) {
	ifstream TheFile(name);
	if(!TheFile) {
		fprintf(stderr,"File %s missing\n",name);
		exit(1);
	}
	char temp[20];
	while(!TheFile.eof()) {
		printf("Loading item\n");
		Item* newItem = new Item();
		// load cost
		TheFile.getline(temp,19);
		newItem->cost = atoi(temp);
		// load icon
		TheFile.getline(temp,19);
		newItem->icon = atoi(temp);
		// load modifier
		TheFile.getline(temp,19);
		newItem->mod = atoi(temp);
		// load name
		TheFile.getline(temp,19);
		char *tempc = temp;
		newItem->name = tempc;
		// load is healing item
		TheFile.getline(temp,4);
		if(atoi(temp) > 0) {
			newItem->bIsHealingItem = 1;
		} else {
			newItem->bIsHealingItem = 0;
		}
		// load is magic
		TheFile.getline(temp,4);
		if(atoi(temp) > 0) {
			newItem->bIsMagic = 1;
		} else {
			newItem->bIsMagic = 0;
		}
		TheFile.getline(temp,4);
		// load is healing spell
		if(atoi(temp) > 0) {
			newItem->bIsHealSpell = 1;
		} else {
			newItem->bIsHealSpell = 0;
		}
		TheFile.getline(temp,4);
		// load is fire spell
		if(atoi(temp) > 0) {
			newItem->bIsFireSpell = 1;
		} else {
			newItem->bIsFireSpell = 0;
		}
		TheFile.getline(temp,4);
		// load is lightning spell
		if(atoi(temp) > 0) {
			newItem->bIsLightningSpell = 1;
		} else {
			newItem->bIsLightningSpell = 0;
		}
		TheFile.getline(temp,4);
		// load is earth spell
		if(atoi(temp) > 0) {
			newItem->bIsEarthSpell = 1;
		} else {
			newItem->bIsEarthSpell = 0;
		}
		TheFile.getline(temp,4);
		// load is meteor spell
		if(atoi(temp) > 0) {
			newItem->bIsMeteor = 1;
		} else {
			newItem->bIsMeteor = 0;
		}
		TheFile.getline(temp,4);
		// load is hand of death
		if(atoi(temp) > 0) {
			newItem->bIsHandOfDeath = 1;
		} else {
			newItem->bIsHandOfDeath = 0;
		}
		TheFile.getline(temp,4);
		// load is full heal spell
		if(atoi(temp) > 0) {
			newItem->bIsFullHeal = 1;
		} else {
			newItem->bIsFullHeal = 0;
		}
		TheFile.getline(temp,4);
		// load is key
		if(atoi(temp) > 0) {
			newItem->bIsKey = 1;
		} else {
			newItem->bIsKey = 0;
		}
		TheFile.getline(temp,4);
		// load is mana
		if(atoi(temp) > 0) {
			newItem->bIsManaPotion = 1;
		} else {
			newItem->bIsManaPotion = 0;
		}
		// load armour class modifier
		TheFile.getline(temp,10);
		newItem->ac_mod = atoi(temp);
		// done, add it in
		printf("Item loaded, adding\n");
		if(newItem->cost == 0 && newItem->mod == 0) {
			printf("Probably a null item.\n");
			//SDL_Delay(1000);
			TheFile.close();
			delete newItem;
			return;
		}
		shopItems.push_back(newItem);
		/*
		// DEBUG ONLY
		printf("Printing out details...\n");
		printf("Loaded item %s:\n",newItem->name.c_str());
		printf("Cost: %i Modifier: %i Icon: %i\n",newItem->cost,newItem->mod,newItem->icon);
		if(newItem->bIsMagic) printf("Is magic\n");
		if(newItem->bIsHealingItem) printf("Is healing item\n");
		if(newItem->bIsHealSpell) printf("Is a healing spell\n");
		if(newItem->bIsFireSpell) printf("Is a fire spell\n");
		if(newItem->bIsLightningSpell) printf("Is a lightning spell\n");
		if(newItem->bIsEarthSpell) printf("Is an earth spell\n");
		if(newItem->bIsMeteor) printf("Is a meteor spell\n");
		if(newItem->bIsHandOfDeath) printf("Is a hand of death\n");
		if(newItem->bIsFullHeal) printf("Is a full heal spell\n");
		*/
		if(TheFile.eof()) {
			TheFile.close();
			return;
		}
	}
	TheFile.close();
	
	/*
		Mana potions
		Full mana potions
		potions 
		Full potions

		
	*/
	
	
	
	/*
	bool bIsHealSpell;
	bool bIsFireSpell;
	bool bIsLightningSpell;
	bool bIsEarthSpell;
	bool bIsMeteor;
	bool bIsHandOfDeath;
	bool bIsFullHeal;*/
}

Item::Item() {
	cost = 0;
	icon = -1; // do not display
	name = "Do Not Display";
	mod = 0;
	bIsMagic = 0;
	bIsHealSpell = 0;
	bIsFullHeal = 0;
	bIsLightningSpell = 0;
	bIsEarthSpell = 0;
	bIsMeteor = 0;
	bIsHandOfDeath = 0;
	bIsFullHeal = 0;
	bIsHealingItem = 0;
	bIsKey = 0;
	count = 1;
}

/*
	ITEM ICON REFERENCE:
	0... Healing potion
	1... Sword of Bling
*/

Shop::Shop() {
	printf("Loading shop...\n");
	loadItems("data/shopdata.rav");
	printf("Shop initialized\n");
}

void CGame::shopKeeping() {
	menuchoice = -1;
	menuoff = -1;
	bool bIsDone = 0;
	int select_x = 0;
	int select_y = 0;
	SDL_Rect iconRect;
	iconRect.x = 0;
	iconRect.y = 0;
	iconRect.w = 48;
	iconRect.h = 48;
	SDL_Rect selectRect;
	selectRect.x = 0;
	selectRect.y = 0;
	selectRect.w = 48;
	selectRect.h = 48;
	// Shop NormalShop;
	while(!bIsDone) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,125));
		if(NormalShop.shopItems.size() == 0) {
			printf("Shop is empty!?!\n");
			return;
		}
		SDL_Rect tempr;
		tempr.x = 360;
		tempr.y = 25;
		tempr.w = 256;
		tempr.h = 256;
		SDL_BlitSurface(icons[7],NULL,screen,&tempr);
		if(menuchoice < 0) {
			menuchoice = 0;
		}
		if(menuoff < 0) {
			menuoff = 0;
		}
		SDL_Color colour = {255,255,255,255};
		SDL_Rect *rect = new SDL_Rect();
		rect->x = 10;
		rect->y = 10;
		int drawn = 0; // temp
		for(int i = 0; i < NormalShop.shopItems.size(); i++) {
			if(i + menuoff < 0) {
				printf("Error check: i+menuoff failed\n");
				break;
			}
			if(NormalShop.shopItems[i+menuoff]) {
				if(i+menuoff == menuchoice) {
					SDL_Rect temp;
					temp.x = rect->x;
					temp.y = rect->y;
					temp.w = 300;
					temp.h = 50;
					SDL_FillRect(screen,&temp,SDL_MapRGB(screen->format,100,0,0));
				}
				//const char* tempstr = NormalShop.shopItems[i-menuoff]->name.c_str();
				char *tempstr = new char[80];
				if(NormalShop.shopItems[i+menuoff]) {
					sprintf(tempstr,"%s for %i x%i",NormalShop.shopItems[i+menuoff]->name.c_str(),NormalShop.shopItems[i+menuoff]->cost,NormalShop.shopItems[i+menuoff]->count);
					int ico = NormalShop.shopItems[i+menuoff]->icon;
					if(NormalShop.shopItems[i+menuoff]->count > 0) {
						SDL_BlitSurface(items[ico],NULL,screen,rect);
					} else {
						// "SOLD OUT" icon
						SDL_BlitSurface(icons[8],NULL,screen,rect);
					}
					rect->x += 48;
					SDL_Surface *text = TTF_RenderText_Solid(font,(const char*)tempstr,colour);
					SDL_BlitSurface(text,NULL,screen,rect);
					SDL_FreeSurface(text);
					rect->x -= 48; // back into icon position
				}
				delete[] tempstr;
				rect->y += 49;
				drawn++;
				if(drawn > 8) {
					if(NormalShop.shopItems.size() - (menuoff + drawn) > 0) {
						SDL_Rect rect;
						rect.x = 340;
						rect.y = RES_Y - 60;
						rect.w = 16;
						rect.h = 16;
						SDL_BlitSurface(icons[6],NULL,screen,&rect); // scroll down
					}
					break;
				}
				// now for the scrolly crap :(
				if(menuoff > 0) {
					SDL_Rect rect;
					rect.x = 340;
					rect.y = 10;
					rect.w = 16;
					rect.h = 16;
					/// draw scroll up icon
					SDL_BlitSurface(icons[5],NULL,screen,&rect);
				}
			}
		}	
		int target_i = menuchoice;

		//printYourMoney(you.gold);

		if(target_i < NormalShop.shopItems.size()) {
			if(NormalShop.shopItems[target_i]->count > 0) {
			// now that we've figured out where...
				printItemInfo(NormalShop.shopItems[target_i]->name,NormalShop.shopItems[target_i]->cost);
			}
		}

		
		SDL_Flip(screen); // update screen surface
		
		// get input
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_ESCAPE) {
					bIsDone = 1;
				}
				else if(event.key.keysym.sym == SDLK_UP) {
					if(menuchoice > 0) {
						menuchoice--;
						int size = NormalShop.shopItems.size()-1;
						printf("I think you are at position %i on screen\n",(menuchoice)-menuoff);
						if((menuchoice)-menuoff < 0) {
							printf("Scrolling up\n");
							menuoff--;
						}
					}
				}
				else if(event.key.keysym.sym == SDLK_DOWN) {
					if(menuchoice < NormalShop.shopItems.size() - 1) {
						menuchoice++;
						int size = NormalShop.shopItems.size()-1;
						printf("I think you're at pos %i\n",(menuchoice)-menuoff);
						if((menuchoice)-menuoff > 8) {
							printf("Scrolling down?\n");
							menuoff++;
						}
					}
				}
				else if(event.key.keysym.sym == SDLK_RETURN) {
					if(target_i < NormalShop.shopItems.size()) {
						if(NormalShop.shopItems[target_i]->count > 0) {
							if(you.gold < NormalShop.shopItems[target_i]->cost) {
								displayFightConsoleMessage("Not enough gold to buy this!",1);
							} else {
								displayFightConsoleMessage("Purchased!",0);
								// take away your moneys!
								you.gold -= NormalShop.shopItems[target_i]->cost;
								NormalShop.shopItems[target_i]->count--;
								// ADD ITEM CRAP HERE
								if(NormalShop.shopItems[target_i]->bIsHealingItem) {
									you.healingpotions++;
								}
								else if(NormalShop.shopItems[target_i]->mod > 0) {
									you.weapon_mod = NormalShop.shopItems[target_i]->mod;
									printf("Bought blade, mod of %i\n",NormalShop.shopItems[target_i]->mod);
									//SDL_Delay(2000);
									you.yourStuff.push_back(NormalShop.shopItems[target_i]);
								}
								else if(NormalShop.shopItems[target_i]->bIsMagic) {
									// magick spells
									if(NormalShop.shopItems[target_i]->bIsHealSpell) {
										you.bHasHealSpell = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsFireSpell) {
										you.bHasFireSpell = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsLightningSpell) {
										you.bHasLightningSpell = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsEarthSpell) {
										you.bHasEarthSpell = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsMeteor) {
										you.bHasMeteor = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsHandOfDeath) {
										you.bHasHandOfDeath = 1;
									}
									else if(NormalShop.shopItems[target_i]->bIsFullHeal) {
										you.bHasFullHeal = 1;
									}
								}
								if(NormalShop.shopItems[target_i]->bIsKey) {
									you.keys++;
								}
								if(NormalShop.shopItems[target_i]->ac_mod > 0) {
									you.ac_mod = NormalShop.shopItems[target_i]->ac_mod;
									printf("Bought armor, AC of %i\n",NormalShop.shopItems[target_i]->ac_mod);
									you.yourStuff.push_back(NormalShop.shopItems[target_i]);
									// will need to equip this.
								}
								if(NormalShop.shopItems[target_i]->bIsManaPotion) {
									you.manapotions++;
								}
							}
						}
					}
				}
			}
		}
	}
}
