#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ravedit.h"

using namespace std;

void RavEditor::loadMap(char *name) {
	// FIXME: still stuck in old mode land, add
	// some extended mode support later

	fflush(stdout);
	
	printf("loading mapfile %s\n",name);
	ifstream TheFile(name);
	if(TheFile==NULL) {
		printf("err: mapfile %s not found\n",name);
		SDL_Quit();
	}
	for(int r=0;r<=LVLH;r++) {
		TheFile.getline(level[r],(LVLW + 1));
	}
	printf("mapfile loaded. parsing\n");
	TheFile.close();
}

void RavEditor::saveMap(char *name) {
	// FIXME: need extended mode support
	ofstream TheFile(name);
	for(int r=0;r<LVLH;r++) {
		for(int c=0;c<LVLW;c++) {
			if(level[r][c] == NULL) {
				TheFile << '0';
			}
			else {
				TheFile << level[r][c];
			}
		}
		TheFile << "\n";
	}
	printf("map file %s written to disk\n",name);
	TheFile.close();
}
