/* FREEZEDIT
	Freezer Level Editor
	Built using SDL and a lot of free hack time

	by el-ravhat
*/

#include "SDL.h"
#include "SDL_image.h"

#include "freezer.h" // symbolic-link it over

#define MAX_TILES 7
#define MAX_HEIGHT LEVEL_HEIGHT
#define MAX_WIDTH LEVEL_WIDTH

// Surfaces;
SDL_Surface *screen;

SDL_Rect currpos;

char level[LEVEL_HEIGHT][LEVEL_WIDTH];

char LoadLevel(char level[MAX_HEIGHT][MAX_WIDTH]);
void editorloop(char level[LEVEL_HEIGHT][LEVEL_WIDTH],SDL_Surface *screen);

int main(int argc, char *argv[])
{
	screen = SDL_SetVideoMode(640,480,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	SDL_WM_SetCaption("The Freezer Editor",NULL);
	printf("Welcome to the Freezer Editor.\n");
	printf("Current environment settings (compiled-in)\n");
	printf("Level height: %i\n",LEVEL_HEIGHT);
	printf("Level width: %i\n",LEVEL_WIDTH);
	printf("Tiles available: %i\n",MAX_TILES);
	LoadLevel(level);
	editorloop(level,screen);
	return 0;
}
