#include "CSRPG.h"
#include "Map.h"
#include <list>
using namespace std;

/*
 * 	utility.cpp
 * 	Holds a lot of very very common functions, like collision.
 *
 * 	Changelog:
 * 		Mike, Apr. 30
 */

//int CGame::open

int CGame::tileCollision(int x, int y) {
	// checks for collisions
	// // COMMUNISM
	list <NPC*>::iterator eit;
	for(eit = characters.begin(); eit != characters.end(); eit++) {
		// DEBUG ONLY
		// go through the list of characters, and see if you are colliding with one.
		// obviously you can't both occupy the same space
		NPC* te = *eit;
		if(te->x == x && te->y == y) {
			return 1;
		}
	}
	// Figure out where to put a manager on how to open the door.
	if(theMap.level[y][x] == '7') {
		// check to see if a door is present, if so do the widget to try and open it
		detectAndOpenDoors(x,y);
		return 1;
	}
	if(theMap.level[y][x] != '1' && theMap.level[y][x] != '5' && x >= 0 && y >= 0 && x < MAP_X_SIZE &&
			y < MAP_Y_SIZE) {
		// "Does not collide" condition, this should always come LAST!!!!
		return 0;
	}
	return 1; // awright the default is "does collide"
}

void CGame::detectAndOpenDoors(int x, int y) {
	printf("Detecting door\n");
	if(theMap.level[y][x] != '7') {
		printf("Not a door\n");
		return;
	}
	if(you.keys < 1) {
		printf("Not enough keys\n");
		return;
	}
	printf("Opening door.\n");
	theMap.level[y][x] = '2'; // reset it to a "normal" door
	you.keys--;
}
