#ifndef _HUDCONTROLLER_H_
#define _HUDCONTROLLER_H_

#include "SDL.h"
#include "SDL_ttf.h"
#include "Player.h"
#include "Quests.h"

/// A basic class for encapsulating all of the UI-style functions. Deprecated.
/** It doesn't run very well. Don't use it. Most of its
 * 	functionality was rolled into the CGame class...*/
class HUDController {
	public:
		/// constructor: inits fonts
		HUDController();

		/// a truetype font, for rendering purposes
		TTF_Font *font; 
		
		//void printMessage(char *str); // prints msg to the bottom
					      // of the screen
		//void printConvo(char *str);   // automagically line-breaks,
						// displays text,
						// then pauses for input
		//Quest* initiateConversation(NPC *plyr,SDL_Surface *screen, int map);
		/// holds all of our quests. DEPRECATED
		QuestMaster *qm;
		//void displayQuestCompletion(SDL_Surface *screen);
		//void drawHUD(Player *plyr,SDL_Surface *screen);
		//void drawEnemy(NPC *plyr, SDL_Surface *screen); // for fight scenes
		//void displayFightConsoleMessage(char *str, SDL_Surface *screen, bool bIsBad);
		//void printItemInfo(string name, int cost, SDL_Surface *screen); // for shop use only
		/// shuts down SDL_ttf and cleans up memory
		void ShutDown();
		/// destructor; does nothing right now.
		~HUDController();
};

#endif
