#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#include "ravedit.h"

void RavEditor::PaintTiles() {
	SDL_Rect temprect;
	SDL_Surface *temp;
	temprect.x = 0;
	temprect.y = 0;
	temprect.w = 48;
	temprect.h = 48;
	
	for(int r = 0; r < LVLH; r++) {
		for(int c = 0; c < LVLW; c++) {
			temprect.x = (c * 48) - (scrollx * 48);
			temprect.y = (r * 48) - (scrolly * 48);
			
			temp = tiles[((int)level[r][c]) - '0'];
			// FIXME: add on to this, extended mode is coming
			// this is the OLD standard mode engine (0-9 tile)

			if(level[r][c] - '0' < 0) {
				temp = tiles[0];
			}

			SDL_BlitSurface(temp,NULL,screen,&temprect);
		}
	}

	// draw "current tile"
	SDL_Rect temprect2;
	temprect2.x = 10;
	temprect2.y = 430;
	temprect2.w = 48;
	temprect2.h = 48;
	SDL_BlitSurface(tiles[selectedTile],NULL,screen,&temprect2);
}
