#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#include "ravedit.h"

void RavEditor::MainLoop() {
	bool working = 1;
	loadMap("default.rav");
	while(working) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,10,10,10));
		PaintTiles();
		FetchInput();
		SDL_Flip(screen);
	}
}

int main(int argc, char *argv[]) {
	printf("raveditor\n");
	atexit(SDL_Quit);
	RavEditor ed;
	ed.MainLoop();
	return 0;
}
