#include "npc.h"
#include "SDL.h"
#include <string>

/*
 * 	NPC.cpp
 * 	Holds the constructor for the NPC class, as well as
 * 	particular functionality.
 */

using namespace std;

NPC::NPC() {
	// sets up the particular defaults for this class.
	// please change them...
	hp = 20;
	hp_max = 20;
	mp = 0;
	mp_max = 0;
	bIsHostile = 0;
	myName = "Mr. Spunky";
	bIsMrQuesty = 0;
	bIsShopKeeper = 0;
	whatToSay0 = "Munt!!!!";
	//whatToSay1 = "Munt!";
	x = 0;
	y = 0;
	//bDrawMe = 0;
	rect.x = 0;
	rect.y = 0;
	rect.w = 48;
	rect.h = 48;
	sprite = 1; // should be the first NPC
	heading = 0;
	mod = 0;
}

void NPC::moveRelative(int dx, int dy) {
	// let's prevent double-move here...
	if(dx > 0) {
		heading = 3;
		dx = 1;
	}
	if(dx < 0) {
		heading = 1;
		dx = -1;
	}
	if(dy > 0) {
		heading = 2;
		dy = 1;
	}
	if(dy < 0) {
		heading = 0;
		dy = -1;
	}
	x += dx;
	y += dy;
}
